<template>
  <div class="details-plot-area d-flex flex-grow-1 flex-column">
    <template v-if="loading">
      <div class="d-flex flex-grow-1">
        <div class="mx-auto my-4">
          <h2 class="text-center mt-4">A carregar...</h2>
          <span class="align-middle">
            <clip-loader :loading="loading" color="#007bff" size="50px" radius="100%"/>
          </span>
        </div>
      </div>
    </template>
    <template v-else>
      <div class="chart-container">
        <base-chart ref="chart" :styles="chartStyle()" :options="chartOptions" :chart-data="chartData"/>
      </div>
    </template>
  </div>
</template>

<script>
import moment from 'moment'
import ClipLoader from 'vue-spinner/src/ClipLoader'
import plotSettings from '@/plots/settings'
import BaseChart from '@/core/charts/mixins/BaseChart'
import { getFeatureInfo, buildFeatureInfoRequestUrl } from '@/featureinfo/request'
import { getComponentsFromLayerName } from '@/featureinfo/process'
import { DEFAULT_CHART_OPTIONS } from '@/plots/chart'

export default {
  name: 'detailsplotarea',

  props: {
    referenceTime: {
      type: Number,
      required: true,
    },

    latitude: {
      type: Number,
      required: true,
    },

    longitude: {
      type: Number,
      required: true,
    },

    plotVariables: {
      type: Array,
      required: true,
    }
  },

  data() {
    return {
      loading: false,
    }
  },

  computed: {
    chartOptions: {
      get() {
        let options = { ...DEFAULT_CHART_OPTIONS }

        options.scales.yAxes = this.plotVariables.map(plotVariable => {
          return plotSettings.getAxisById(
            plotSettings.getSettingsForVariable(plotVariable).dataType.yAxisID
          )
        }).filter((axis, index, arr) => {
          return arr.indexOf(axis) === index
        }).map((axis, index) => {
          return {
            ...axis,
            position: index % 2 === 0 ? 'left' : 'right'
          }
        })

        return options
      }
    },
  },

  asyncComputed: {
    async chartData() {
      this.loading = true

      let datasets = []
      for(let i = 0; i < this.plotVariables.length; i++) {
        let plotVariable = this.plotVariables[i]
        let components = getComponentsFromLayerName(plotVariable)
        let layerName = `${components.model}.${components.name}`

        let url = buildFeatureInfoRequestUrl({
          layer: `${components.model}.${components.name}`,
          latitude: this.latitude,
          longitude: this.longitude,
          reference_time: moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:00:00[Z]'),
          time: [...Array(72).keys()].map(h => {
            return moment.unix(this.referenceTime).add(h, 'hour').format('YYYY-MM-DDTHH:00:00')
          })
        })

        try {
          let response = await getFeatureInfo(url)
          let data = response.data.properties[layerName].filter(item => item.level === components.level)
          let plotData = plotSettings.getSettingsForVariable(plotVariable).process(data)

          datasets.push({
            ...plotSettings.getSettingsForVariable(plotVariable).dataType,
            data: plotData,
          })
        }catch(error) {
          window.console.log(error)
        }
      }

      this.loading = false

      return { datasets: datasets }
    }
  },

  methods: {
    chartStyle() {
      return { height: '300px', position: 'relative' }
    },
  },

  components: {
    ClipLoader,
    BaseChart
  },
}
</script>

<style scoped>
.chart-container {
  display: block;
  position: relative;
  height: 300px;
  max-height: 300px;
  width: 90%;
}
</style>
